Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_tvd_crs.F90	(revision 6772)
@@ -91,4 +91,5 @@
       !!----------------------------------------------------------------------
       !
+
       IF( nn_timing == 1 )  CALL timing_start('tra_adv_tvd')
       !
@@ -126,6 +127,6 @@
          ! upstream tracer flux in the i and j direction
          DO jk = 1, jpkm1
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   ! upstream scheme
                   zfp_ui = pun(ji,jj,jk) + ABS( pun(ji,jj,jk) )
@@ -138,13 +139,15 @@
             END DO
          END DO
+         CALL crs_lbc_lnk( zwx, 'U', -1._wp )  
+         CALL crs_lbc_lnk( zwy, 'V', -1._wp )  
          ! upstream tracer flux in the k direction
          ! Surface value
          IF( lk_vvl ) THEN   ;   zwz(:,:, 1 ) = 0.e0                         ! volume variable
-         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) * ptb(:,:,1,jn)   ! linear free surface 
+         ELSE                ;   zwz(:,:, 1 ) = pwn(:,:,1) !cbr * ptb(:,:,1,jn)   ! linear free surface 
          ENDIF
          ! Interior value
          DO jk = 2, jpkm1
-            DO jj = 1, jpj
-               DO ji = 1, jpi
+            DO jj = 2,  jpj_crs-1
+               DO ji = nldi_crs, nlei_crs
                   zfp_wk = pwn(ji,jj,jk) + ABS( pwn(ji,jj,jk) )
                   zfm_wk = pwn(ji,jj,jk) - ABS( pwn(ji,jj,jk) )
@@ -153,9 +156,11 @@
             END DO
          END DO
+         CALL crs_lbc_lnk( zwz, 'T', 1. )  
+
          ! total advective trend
          DO jk = 1, jpkm1
             z2dtt = p2dt(jk)
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   zbtr = r1_bt_crs(ji,jj,jk) 
                   ! total intermediate advective trends
@@ -163,5 +168,5 @@
                      &             + zwy(ji,jj,jk) - zwy(ji  ,jj-1,jk  )   &
                      &             + zwz(ji,jj,jk) - zwz(ji  ,jj  ,jk+1) )
-                  ! update and guess with monotonic sheme
+
                   pta(ji,jj,jk,jn) =   pta(ji,jj,jk,jn)         + ztra
                   zwi(ji,jj,jk)    = ( ptb(ji,jj,jk,jn) + z2dtt * ztra ) * tmask_crs(ji,jj,jk)
@@ -169,4 +174,5 @@
             END DO
          END DO
+ 
          !                             ! Lateral boundary conditions on zwi  (unchanged sign)
          CALL crs_lbc_lnk( zwi, 'T', 1. )  
@@ -187,6 +193,6 @@
          ! antidiffusive flux on i and j
          DO jk = 1, jpkm1
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   zwx(ji,jj,jk) = 0.5 * pun(ji,jj,jk) * ( ptn(ji,jj,jk,jn) + ptn(ji+1,jj,jk,jn) ) - zwx(ji,jj,jk)
                   zwy(ji,jj,jk) = 0.5 * pvn(ji,jj,jk) * ( ptn(ji,jj,jk,jn) + ptn(ji,jj+1,jk,jn) ) - zwy(ji,jj,jk)
@@ -198,10 +204,10 @@
          !
          DO jk = 2, jpkm1          ! Interior value
-            DO jj = 1, jpj
-               DO ji = 1, jpi
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   zwz(ji,jj,jk) = 0.5 * pwn(ji,jj,jk) * ( ptn(ji,jj,jk,jn) + ptn(ji,jj,jk-1,jn) ) - zwz(ji,jj,jk)
                END DO
             END DO
-         END DO
+        END DO
          CALL crs_lbc_lnk( zwx, 'U', -1. )   ;   CALL crs_lbc_lnk( zwy, 'V', -1. )         ! Lateral bondary conditions
          CALL crs_lbc_lnk( zwz, 'W',  1. )
@@ -214,6 +220,6 @@
          ! ------------------------------------
          DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.  
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   zbtr = r1_bt_crs(ji,jj,jk)
                   ! total advective trends
@@ -247,4 +253,5 @@
       END DO
       !
+
                    CALL wrk_dealloc( jpi, jpj, jpk, zwi, zwz , zwx, zwy )
       IF( l_trd )  CALL wrk_dealloc( jpi, jpj, jpk, ztrdx, ztrdy, ztrdz )
@@ -302,6 +309,6 @@
          ikm1 = MAX(jk-1,1)
          z2dtt = p2dt(jk)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crs-1
+            DO ji = 2, jpi_crs-1
 
                ! search maximum in neighbourhood
@@ -339,6 +346,6 @@
       ! ----------------------------------------
       DO jk = 1, jpkm1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
+         DO jj = 2, jpj_crs-1
+            DO ji = 2, jpi_crs-1
                zau = MIN( 1.e0, zbetdo(ji,jj,jk), zbetup(ji+1,jj,jk) )
                zbu = MIN( 1.e0, zbetup(ji,jj,jk), zbetdo(ji+1,jj,jk) )
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_iso_crs.F90	(revision 6772)
@@ -10,5 +10,5 @@
    !!            3.3  !  2010-09  (C. Ethe, G. Madec) Merge TRA-TRC
    !!----------------------------------------------------------------------
-#if   defined key_ldfslp   ||   defined key_esopa
+#if   ( defined key_ldfslp   ||   defined key_esopa ) && defined key_crs
    !!----------------------------------------------------------------------
    !!   'key_ldfslp'               slope of the lateral diffusive direction
@@ -19,10 +19,4 @@
    !!                  the isopycnal or geopotential s-coord. operator 
    !!----------------------------------------------------------------------
-!   USE oce             ! ocean dynamics and active tracers
-!   USE dom_oce         ! ocean space and time domain
-!   USE trc_oce         ! share passive tracers/Ocean variables
-!   USE zdf_oce         ! ocean vertical physics
-!   USE ldftra_oce      ! ocean active tracers: lateral physics
-!   USE ldfslp          ! iso-neutral slopes
    USE ldfslp_crs          ! iso-neutral slopes
    USE diaptr          ! poleward transport diagnostics
@@ -35,5 +29,4 @@
    USE wrk_nemo        ! Memory Allocation
    USE timing          ! Timing
-!   USE crs
    USE oce_trc
    USE iom, ONLY : iom_put,iom_swap
@@ -113,4 +106,5 @@
       REAL(wp)                         ::   zztmp               ! local scalar
 #endif
+      REAL(wp)                         ::   zmin,zmax
       REAL(wp), POINTER, DIMENSION(:,:  ) ::  zdkt, zdk1t, z2d
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  zdit, zdjt, ztfw , zftu,  zftv 
@@ -188,6 +182,6 @@
                      &             + tmask_crs(ji,jj+1,jk+1) + tmask_crs(ji,jj,jk  ), 1. )
                   !
-                  zcof1 = - fsahtu(ji,jj,jk) * e2e3u_msk(ji,jj,jk) * uslp_crs(ji,jj,jk) * zmsku / MAX( 1._wp , e3u_max_crs(ji,jj,jk))
-                  zcof2 = - fsahtv(ji,jj,jk) * e1e3v_msk(ji,jj,jk) * vslp_crs(ji,jj,jk) * zmskv / MAX( 1._wp , e3v_max_crs(ji,jj,jk))
+                  zcof1 = - fsahtu(ji,jj,jk) * e2e3u_msk(ji,jj,jk) * uslp_crs(ji,jj,jk) * zmsku / MAX( 1._wp , fse3u_max_crs(ji,jj,jk))
+                  zcof2 = - fsahtv(ji,jj,jk) * e1e3v_msk(ji,jj,jk) * vslp_crs(ji,jj,jk) * zmskv / MAX( 1._wp , fse3v_max_crs(ji,jj,jk))
                   !
                   zftu(ji,jj,jk ) = ( zabe1 * zdit(ji,jj,jk)   &
@@ -199,8 +193,4 @@
                END DO
             END DO
-            CALL iom_swap( "nemo_crs"  )
-            CALL iom_put( "zftu" , zftu )
-            CALL iom_put( "zftv" , zftv )
-            CALL iom_swap( "nemo" )
 
             ! II.4 Second derivative (divergence) and add to the general trend
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap_crs.F90	(revision 6772)
@@ -124,9 +124,9 @@
                      ikv = mbkv_crs(ji,jj)
                      IF( iku == jk ) THEN
-                        zabe1 = fsahtu(ji,jj,iku) * umask_crs(ji,jj,iku) * e1ur(ji,jj) * e3u_crs(ji,jj,iku)
+                        zabe1 = fsahtu(ji,jj,iku) * umask_crs(ji,jj,iku) * e1ur(ji,jj) * fse3u_crs(ji,jj,iku)
                         ztu(ji,jj,jk) = zabe1 * pgu(ji,jj,jn)
                      ENDIF
                      IF( ikv == jk ) THEN
-                        zabe2 = fsahtv(ji,jj,ikv) * vmask_crs(ji,jj,ikv) * e2vr(ji,jj) * e3v_crs(ji,jj,ikv)
+                        zabe2 = fsahtv(ji,jj,ikv) * vmask_crs(ji,jj,ikv) * e2vr(ji,jj) * fse3v_crs(ji,jj,ikv)
                         ztv(ji,jj,jk) = zabe2 * pgv(ji,jj,jn)
                      ENDIF
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/tranxt.F90	(revision 6772)
@@ -49,4 +49,5 @@
    USE agrif_opa_interp
 #endif
+   USE crs
 
    IMPLICIT NONE
@@ -56,4 +57,5 @@
    PUBLIC   tra_nxt_fix   ! to be used in trcnxt
    PUBLIC   tra_nxt_vvl   ! to be used in trcnxt
+   PUBLIC   tra_nxt_vvl_crs ! to be used in trcnxt
 
    REAL(wp) ::   rbcp   ! Brown & Campana parameters for semi-implicit hpg
@@ -349,4 +351,112 @@
    END SUBROUTINE tra_nxt_vvl
 
+  SUBROUTINE tra_nxt_vvl_crs( kt, kit000, p2dt, cdtype, ptb, ptn, pta, psbc_tc, psbc_tc_b, kjpt )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE tra_nxt_vvl  ***
+      !!
+      !! ** Purpose :   Time varying volume: apply the Asselin time filter  
+      !!                and swap the tracer fields.
+      !! 
+      !! ** Method  : - Apply a thickness weighted Asselin time filter on now fields.
+      !!              - save in (ta,sa) a thickness weighted average over the three 
+      !!             time levels which will be used to compute rdn and thus the semi-
+      !!             implicit hydrostatic pressure gradient (ln_dynhpg_imp = T)
+      !!              - swap tracer fields to prepare the next time_step.
+      !!                This can be summurized for tempearture as:
+      !!             ztm = ( e3t_n*tn + rbcp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )   ln_dynhpg_imp = T
+      !!                  /( e3t_n    + rbcp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )   
+      !!             ztm = 0                                                       otherwise
+      !!             tb  = ( e3t_n*tn + atfp*[ e3t_b*tb - 2 e3t_n*tn + e3t_a*ta ] )
+      !!                  /( e3t_n    + atfp*[ e3t_b    - 2 e3t_n    + e3t_a    ] )
+      !!             tn  = ta 
+      !!             ta  = zt        (NB: reset to 0 after eos_bn2 call)
+      !!
+      !! ** Action  : - (tb,sb) and (tn,sn) ready for the next time step
+      !!              - (ta,sa) time averaged (t,s)   (ln_dynhpg_imp = T)
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in   )                               ::  kt       ! ocean time-step index
+      INTEGER         , INTENT(in   )                               ::  kit000   ! first time step index
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpk)               ::  p2dt     ! time-step
+      CHARACTER(len=3), INTENT(in   )                               ::  cdtype   ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                               ::  kjpt     ! number of tracers
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptb      ! before tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  ptn      ! now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)  ::  pta      ! tracer trend
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,kjpt)      ::  psbc_tc   ! surface tracer content
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,kjpt)      ::  psbc_tc_b ! before surface tracer content
+
+      !!     
+      LOGICAL  ::   ll_tra_hpg, ll_traqsr, ll_rnf   ! local logical
+      INTEGER  ::   ji, jj, jk, jn              ! dummy loop indices
+      REAL(wp) ::   zfact1, ztc_a , ztc_n , ztc_b , ztc_f , ztc_d    ! local scalar
+      REAL(wp) ::   zfact2, ze3t_b, ze3t_n, ze3t_a, ze3t_f, ze3t_d   !   -      -
+      !!----------------------------------------------------------------------
+      !!----------------------------------------------------------------------
+      !
+      IF( kt == kit000 )  THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'tra_nxt_vvl : time stepping', cdtype
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      ENDIF
+      !
+      IF( cdtype == 'TRA' )  THEN
+         ll_tra_hpg = ln_dynhpg_imp    ! active  tracers case  and  semi-implicit hpg
+         ll_traqsr  = ln_traqsr        ! active  tracers case  and  solar penetration
+         ll_rnf     = ln_rnf           ! active  tracers case  and  river runoffs
+      ELSE
+         ll_tra_hpg = .FALSE.          ! passive tracers case or NO semi-implicit hpg
+         ll_traqsr  = .FALSE.          ! active  tracers case and NO solar penetration
+         ll_rnf     = .FALSE.          ! passive tracers or NO river runoffs
+      ENDIF
+      !
+      DO jn = 1, kjpt
+         DO jk = 1, jpkm1
+            zfact1 = atfp * p2dt(jk)
+            zfact2 = zfact1 / rau0
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ze3t_b = fse3t_b_crs(ji,jj,jk)
+                  ze3t_n = fse3t_n_crs(ji,jj,jk)
+                  ze3t_a = fse3t_a_crs(ji,jj,jk)
+                  !                                         ! tracer content at Before, now and after
+                  ztc_b  = ptb(ji,jj,jk,jn) * ze3t_b
+                  ztc_n  = ptn(ji,jj,jk,jn) * ze3t_n
+                  ztc_a  = pta(ji,jj,jk,jn) * ze3t_a
+                  !
+                  ze3t_d = ze3t_a - 2. * ze3t_n + ze3t_b
+                  ztc_d  = ztc_a  - 2. * ztc_n  + ztc_b
+                  !
+                  ze3t_f = ze3t_n + atfp * ze3t_d
+                  ztc_f  = ztc_n  + atfp * ztc_d
+                  !
+                  IF( jk == 1 ) THEN           ! first level 
+                     ze3t_f = ze3t_f - zfact2 * ( emp_b_crs(ji,jj) - emp_crs(ji,jj) + rnf_crs(ji,jj) - rnf_b_crs(ji,jj) )
+                     ztc_f  = ztc_f  - zfact1 * ( psbc_tc(ji,jj,jn) - psbc_tc_b(ji,jj,jn) )
+                  ENDIF
+!cbr as it is a subroutine dedicated to crs, TRA options are not necessary
+!cbr                  IF( ll_traqsr .AND. jn == jp_tem .AND. jk <= nksr )   &     ! solar penetration (temperature only)
+!cbr                     &     ztc_f  = ztc_f  - zfact1 * ( qsr_hc(ji,jj,jk) - qsr_hc_b(ji,jj,jk) )
+!cbr
+!cbr                  IF( ll_rnf .AND. jk <= nk_rnf(ji,jj) )   &                  ! river runoffs
+!cbr                     &     ztc_f  = ztc_f  - zfact1 * ( rnf_tsc(ji,jj,jn) - rnf_tsc_b(ji,jj,jn) ) &
+!cbr                     &                              * fse3t_n(ji,jj,jk) / h_rnf(ji,jj)
+
+                  ze3t_f = 1.e0 / ze3t_f
+                  ptb(ji,jj,jk,jn) = ztc_f * ze3t_f       ! ptb <-- ptn filtered
+                  ptn(ji,jj,jk,jn) = pta(ji,jj,jk,jn)     ! ptn <-- pta
+                  !
+                  IF( ll_tra_hpg ) THEN        ! semi-implicit hpg (T & S only)
+                     ze3t_d           = 1.e0   / ( ze3t_n + rbcp * ze3t_d )
+                     pta(ji,jj,jk,jn) = ze3t_d * ( ztc_n  + rbcp * ztc_d  )   ! ta <-- Brown & Campana average
+                  ENDIF
+               END DO
+            END DO
+         END DO
+         ! 
+      END DO
+      !
+   END SUBROUTINE tra_nxt_vvl_crs
+
+
    !!======================================================================
 END MODULE tranxt
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/trazdf_imp_crs.F90	(revision 6772)
@@ -78,4 +78,5 @@
       !! ** Action  : - pta  becomes the after tracer
       !!---------------------------------------------------------------------
+      USE ieee_arithmetic
       !
       INTEGER                              , INTENT(in   ) ::   kt       ! ocean time-step index
@@ -90,4 +91,5 @@
       REAL(wp) ::  zrhs, ze3tb, ze3tn, ze3ta   ! local scalars
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  zwi, zwt,zwd,zws
+      REAL(wp) ::  zmin,zmax
       !!---------------------------------------------------------------------
       !
@@ -135,7 +137,7 @@
                END DO
             ELSE IF( l_traldf_rot ) THEN     ! standard isoneutral diff
-               DO jk = 2, jpkm1
-                  DO jj = 2, jpjm1
-                     DO ji = fs_2, fs_jpim1   ! vector opt.
+              DO jk = 2, jpkm1
+                  DO jj = 2, jpj_crs-1
+                     DO ji = 2, jpi_crs-1
                         zwt(ji,jj,jk) = zwt(ji,jj,jk) + fsahtw(ji,jj,jk)                       &
                            &                          * (  wslpi_crs(ji,jj,jk) * wslpi_crs(ji,jj,jk)   &
@@ -148,12 +150,18 @@
 #endif
             DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * e3t_crs(ji,jj,jk)   ! after scale factor at T-point
-                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * e3t_crs(ji,jj,jk)   ! now   scale factor at T-point
+               DO jj = 2, jpj_crs-1
+                  DO ji = 2, jpi_crs-1
+
+#if defined key_vvl
+                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * fse3t_a_crs(ji,jj,jk)   ! after scale factor at T-point
+                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * fse3t_n_crs(ji,jj,jk)   ! now   scale factor at T-point
+#else
+                     ze3ta =  ( 1. - r_vvl ) +        r_vvl   * e3t_0_crs(ji,jj,jk)   ! after scale factor at T-point
+                     ze3tn =         r_vvl   + ( 1. - r_vvl ) * e3t_0_crs(ji,jj,jk)   ! now   scale factor at T-point
+#endif
                      !cbr zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_1d(jk  ) )  !cc
                      !cbr zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_1d(jk+1) )  !cc
-                     zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * e3w_max_crs(ji,jj,jk) )
-                     zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * e3w_max_crs(ji,jj,jk+1) )
+                     zwi(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk  ) / ( ze3tn * fse3w_max_crs(ji,jj,jk) )
+                     zws(ji,jj,jk) = - p2dt(jk) * zwt(ji,jj,jk+1) / ( ze3tn * fse3w_max_crs(ji,jj,jk+1) )
                      zwd(ji,jj,jk) = ze3ta - zwi(ji,jj,jk) - zws(ji,jj,jk)
                  END DO
@@ -182,12 +190,12 @@
             ! first recurrence:   Tk = Dk - Ik Sk-1 / Tk-1   (increasing k)
             ! done once for all passive tracers (so included in the IF instruction)
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   zwt(ji,jj,1) = zwd(ji,jj,1)
                END DO
             END DO
             DO jk = 2, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1
+               DO jj = 2, jpj_crs-1
+                  DO ji = 2, jpi_crs-1
                     zwt(ji,jj,jk) = zwd(ji,jj,jk) - zwi(ji,jj,jk) * zws(ji,jj,jk-1) / zwt(ji,jj,jk-1)
                   END DO
@@ -198,8 +206,13 @@
          !    
          ! second recurrence:    Zk = Yk - Ik / Tk-1  Zk-1
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
-               ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,1)
-               ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,1)
+         DO jj = 2, jpj_crs-1
+            DO ji = 2, jpi_crs-1
+#if defined key_vvl
+               ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b_crs(ji,jj,1)
+               ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t_n_crs(ji,jj,1)
+#else
+               ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,1)
+               ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,1)
+#endif
                pta(ji,jj,1,jn) = ze3tb * ptb(ji,jj,1,jn) + p2dt(1) * ze3tn * pta(ji,jj,1,jn)
             END DO
@@ -207,11 +220,15 @@
 
          DO jk = 2, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1
-                  ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,jk)
-                  ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_crs(ji,jj,jk)
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
+#if defined key_vvl
+                  ze3tb = ( 1. - r_vvl ) + r_vvl * fse3t_b_crs(ji,jj,jk)
+                  ze3tn = ( 1. - r_vvl ) + r_vvl * fse3t_n_crs(ji,jj,jk)
+#else
+                  ze3tb = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,jk)
+                  ze3tn = ( 1. - r_vvl ) + r_vvl * e3t_0_crs(ji,jj,jk)
+#endif
                   zrhs = ze3tb * ptb(ji,jj,jk,jn) + p2dt(jk) * ze3tn * pta(ji,jj,jk,jn)   ! zrhs=right hand side 
-                  pta(ji,jj,jk,jn) = zrhs - zwi(ji,jj,jk) / zwt(ji,jj,jk-1) * pta(ji,jj,jk-1,jn)
-                
+                  pta(ji,jj,jk,jn) = zrhs  - zwi(ji,jj,jk) / zwt(ji,jj,jk-1) * pta(ji,jj,jk-1,jn)
                END DO
             END DO
@@ -219,19 +236,17 @@
 
          ! third recurrence:    Xk = (Zk - Sk Xk+1 ) / Tk   (result is the after tracer)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1
+         DO jj = 2, jpj_crs-1
+            DO ji = 2, jpi_crs-1
                pta(ji,jj,jpkm1,jn) = pta(ji,jj,jpkm1,jn) / zwt(ji,jj,jpkm1) * tmask_crs(ji,jj,jpkm1)
             END DO
          END DO
          DO jk = jpk-2, 1, -1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1
+            DO jj = 2, jpj_crs-1
+               DO ji = 2, jpi_crs-1
                   pta(ji,jj,jk,jn) = ( pta(ji,jj,jk,jn) - zws(ji,jj,jk) * pta(ji,jj,jk+1,jn) )   &
-                     &             / zwt(ji,jj,jk) * tmask_crs(ji,jj,jk)
-                 
-               END DO
-            END DO
-         END DO
-
+                    &             / zwt(ji,jj,jk) * tmask_crs(ji,jj,jk)
+              END DO
+            END DO
+         END DO
          !                                            ! ================= !
       END DO                                          !  end tracer loop  !
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde_crs.F90	(revision 6772)
@@ -96,6 +96,4 @@
       INTEGER  ::   iku, ikv, ikum1, ikvm1   ! partial step level (ocean bottom level) at u- and v-points
       REAL(wp) ::  ze3wu, ze3wv, zmaxu, zmaxv  ! temporary scalars
-  !cc    REAL(wp), POINTER, DIMENSION(:,:  ) ::  zri, zrj, zhi, zhj
-  !cc    REAL(wp), POINTER, DIMENSION(:,:,:) ::  zti, zte    ! interpolated value of tracer
       REAL(wp), ALLOCATABLE, DIMENSION(:,:  ) ::  zri, zrj, zhi, zhj
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  zti, zte    ! interpolated value of tracer
@@ -105,6 +103,4 @@
       IF( nn_timing == 1 )  CALL timing_start( 'zps_hde_crs')
       !
-!!      CALL wrk_alloc( jpi, jpj,       zri, zrj, zhi, zhj ) 
-!!      CALL wrk_alloc( jpi, jpj, kjpt, zti, zte           ) 
       ALLOCATE( zri(jpi_crs,jpj_crs) , zrj(jpi_crs,jpj_crs), zte(jpi_crs ,jpj_crs ,kjpt), &
          &      zhi(jpi_crs,jpj_crs) , zhj(jpi_crs,jpj_crs), zti(jpi_crs ,jpj_crs ,kjpt))
@@ -112,22 +108,19 @@
       DO jn = 1, kjpt      !==   Interpolation of tracers at the last ocean level   ==!
          !
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
-# else
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
-# endif
+
                iku = mbku_crs(ji,jj)   ;   ikum1 = MAX( iku - 1 , 1 )    ! last and before last ocean level at u- & v-points
                ikv = mbkv_crs(ji,jj)   ;   ikvm1 = MAX( ikv - 1 , 1 )    ! if level first is a p-step, ik.m1=1
-          !     ze3wu = e3w_crs(ji+1,jj  ,iku) - e3w_crs(ji,jj,iku)
-          !     ze3wv = e3w_crs(ji  ,jj+1,ikv) - e3w_crs(ji,jj,ikv)
-               ze3wu = e3w_max_crs(ji+1,jj  ,iku) - e3w_max_crs(ji,jj,iku)
-               ze3wv = e3w_max_crs(ji  ,jj+1,ikv) - e3w_max_crs(ji,jj,ikv)
+               ze3wu = e3w_max_0_crs(ji+1,jj  ,iku) - e3w_max_0_crs(ji,jj,iku)
+               ze3wv = e3w_max_0_crs(ji  ,jj+1,ikv) - e3w_max_0_crs(ji,jj,ikv)
                !
                ! i- direction
                IF( ze3wu >= 0._wp ) THEN      ! case 1
-                  zmaxu =  ze3wu / e3w_max_crs(ji+1,jj,iku)  
-                 !    zmaxu =  ze3wu / e3w_crs(ji+1,jj,iku)
+#if defined key_vvl
+                  zmaxu =  ze3wu / e3w_max_n_crs(ji+1,jj,iku)  
+#else
+                  zmaxu =  ze3wu / e3w_max_0_crs(ji+1,jj,iku)  
+#endif
                   ! interpolated values of tracers
                   zti(ji,jj,jn) = pta(ji+1,jj,iku,jn) + zmaxu * ( pta(ji+1,jj,ikum1,jn) - pta(ji+1,jj,iku,jn) )
@@ -135,6 +128,9 @@
                   pgtu(ji,jj,jn) = umask_crs(ji,jj,1) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
                ELSE                           ! case 2
-                  zmaxu = -ze3wu / e3w_max_crs(ji,jj,iku)
-                 !    zmaxu = -ze3wu / e3w_crs(ji,jj,iku)
+#if defined key_vvl
+                  zmaxu = -ze3wu / e3w_max_n_crs(ji,jj,iku)
+#else
+                  zmaxu = -ze3wu / e3w_max_0_crs(ji,jj,iku)
+#endif
                   ! interpolated values of tracers
                   zti(ji,jj,jn) = pta(ji,jj,iku,jn) + zmaxu * ( pta(ji,jj,ikum1,jn) - pta(ji,jj,iku,jn) )
@@ -145,6 +141,9 @@
                ! j- direction
                IF( ze3wv >= 0._wp ) THEN      ! case 1
-                  zmaxv =  ze3wv / e3w_max_crs(ji,jj+1,ikv)
-               !      zmaxv =  ze3wv / e3w_crs(ji,jj+1,ikv)
+#if defined key_vvl
+                  zmaxv =  ze3wv / e3w_max_n_crs(ji,jj+1,ikv)
+#else
+                  zmaxv =  ze3wv / e3w_max_0_crs(ji,jj+1,ikv)
+#endif
                   ! interpolated values of tracers
                   zte(ji,jj,jn) = pta(ji,jj+1,ikv,jn) + zmaxv * ( pta(ji,jj+1,ikvm1,jn) - pta(ji,jj+1,ikv,jn) )
@@ -152,6 +151,9 @@
                   pgtv(ji,jj,jn) = vmask_crs(ji,jj,1) * ( zte(ji,jj,jn) - pta(ji,jj,ikv,jn) )
                ELSE                           ! case 2
-                  zmaxv =  -ze3wv / e3w_max_crs(ji,jj,ikv)
-                !     zmaxv = -ze3wv / e3w_crs(ji,jj,ikv)
+#if defined key_vvl
+                  zmaxv =  -ze3wv / e3w_max_n_crs(ji,jj,ikv)
+#else
+                  zmaxv =  -ze3wv / e3w_max_0_crs(ji,jj,ikv)
+#endif
                   ! interpolated values of tracers
                   zte(ji,jj,jn) = pta(ji,jj,ikv,jn) + zmaxv * ( pta(ji,jj,ikvm1,jn) - pta(ji,jj,ikv,jn) )
@@ -160,53 +162,38 @@
                ENDIF
 
-# if ! defined key_vectopt_loop
             END DO
-# endif
          END DO
          CALL crs_lbc_lnk( pgtu(:,:,jn), 'U', -1. )   ;   CALL crs_lbc_lnk( pgtv(:,:,jn), 'V', -1. )   ! Lateral boundary cond.
          !
       END DO
-!WRITE(numout,*) ' test24 ', e3w_max_crs
+
       ! horizontal derivative of density anomalies (rd)
       IF( PRESENT( prd ) ) THEN         ! depth of the partial step level
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
-# else
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
-# endif
+
                iku = mbku_crs(ji,jj)
                ikv = mbkv_crs(ji,jj)
-   !cc             ze3wu  = e3w_max_crs(ji+1,jj  ,iku) - e3w_max_crs(ji,jj,iku)   !gradiant horizontal pas de max
-               ze3wu  = e3w_crs(ji+1,jj  ,iku) - e3w_crs(ji,jj,iku)
-       !cc        ze3wv  = e3w_max_crs(ji  ,jj+1,ikv) - e3w_max_crs(ji,jj,ikv)
-               ze3wv  = e3w_crs(ji  ,jj+1,ikv) - e3w_crs(ji,jj,ikv)
-               IF( ze3wu >= 0._wp ) THEN   ;   zhi(ji,jj) = gdept_crs(ji  ,jj,iku)     ! i-direction: case 1
-               ELSE                        ;   zhi(ji,jj) = gdept_crs(ji+1,jj,iku)     ! -     -      case 2
-               ENDIF
-               IF( ze3wv >= 0._wp ) THEN   ;   zhj(ji,jj) = gdept_crs(ji,jj  ,ikv)     ! j-direction: case 1
-               ELSE                        ;   zhj(ji,jj) = gdept_crs(ji,jj+1,ikv)     ! -     -      case 2
-               ENDIF
-# if ! defined key_vectopt_loop
+               ze3wu  = e3w_0_crs(ji+1,jj  ,iku) - e3w_0_crs(ji,jj,iku)
+               ze3wv  = e3w_0_crs(ji  ,jj+1,ikv) - e3w_0_crs(ji,jj,ikv)
+               IF( ze3wu >= 0._wp ) THEN   ;   zhi(ji,jj) = fsdept_crs(ji  ,jj,iku)     ! i-direction: case 1
+               ELSE                        ;   zhi(ji,jj) = fsdept_crs(ji+1,jj,iku)     ! -     -      case 2
+               ENDIF
+               IF( ze3wv >= 0._wp ) THEN   ;   zhj(ji,jj) = fsdept_crs(ji,jj  ,ikv)     ! j-direction: case 1
+               ELSE                        ;   zhj(ji,jj) = fsdept_crs(ji,jj+1,ikv)     ! -     -      case 2
+               ENDIF
+
             END DO
-# endif
          END DO
          CALL eos_crs( zti, zhi, zri )  
          CALL eos_crs( zte, zhj, zrj )
+
          ! Gradient of density at the last level 
-# if defined key_vectopt_loop
-         jj = 1
-         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
-# else
          DO jj = 1, jpjm1
             DO ji = 1, jpim1
-# endif
                iku = mbku_crs(ji,jj)
                ikv = mbkv_crs(ji,jj)
-      !         ze3wu  = e3w_max_crs(ji+1,jj  ,iku) - e3w_max_crs(ji,jj,iku)         gradient horizontal
-                ze3wu  = e3w_crs(ji+1,jj  ,iku) - e3w_crs(ji,jj,iku)
-      !         ze3wv  = e3w_max_crs(ji  ,jj+1,ikv) - e3w_max_crs(ji,jj,ikv)         gradient horizontal
-                ze3wv  = e3w_crs(ji  ,jj+1,ikv) - e3w_crs(ji,jj,ikv)
+                ze3wu  = e3w_0_crs(ji+1,jj  ,iku) - e3w_0_crs(ji,jj,iku)
+                ze3wv  = e3w_0_crs(ji  ,jj+1,ikv) - e3w_0_crs(ji,jj,ikv)
                IF( ze3wu >= 0._wp ) THEN   ;   pgru(ji,jj) = umask_crs(ji,jj,1) * ( zri(ji  ,jj) - prd(ji,jj,iku) )   ! i: 1
                ELSE                        ;   pgru(ji,jj) = umask_crs(ji,jj,1) * ( prd(ji+1,jj,iku) - zri(ji,jj) )   ! i: 2
@@ -215,9 +202,7 @@
                ELSE                        ;   pgrv(ji,jj) = vmask_crs(ji,jj,1) * ( prd(ji,jj+1,ikv) - zrj(ji,jj) )   ! j: 2
                ENDIF
-# if ! defined key_vectopt_loop
+
             END DO
-# endif
          END DO
-
 
          CALL crs_lbc_lnk( pgru , 'U', -1. )   ;   CALL crs_lbc_lnk( pgrv , 'V', -1. )   ! Lateral boundary conditions
@@ -225,6 +210,4 @@
       END IF
       !
-      !!ccCALL wrk_dealloc( jpi, jpj,       zri, zrj, zhi, zhj ) 
-      !!ccCALL wrk_dealloc( jpi, jpj, kjpt, zti, zte           ) 
       DEALLOCATE( zri , zrj, zte, zhi, zhj, zti)
       !
